%define anolis_release 2

Name:		qpl
Version:	0.2.0
Release:	%{anolis_release}%{?dist}
Summary:	Intel® Query Processing Library (Intel® QPL)
License:	MIT
URL:		https://github.com/intel/qpl
Source0:	https://github.com/intel/qpl/archive/refs/tags/v%{version}.tar.gz

Patch1001:	1001-bugfix-fix-google-test-21.0.patch
Patch1002:	1002-remove-error-in-examples.patch
Patch1003:	1003-remove-stress-test.patch

BuildRequires:	nasm > 2.15.0
BuildRequires:  gcc > 8.2 clang > 12.0.1
BuildRequires:  libuuid-devel >=  2.35.2
BuildRequires:  cmake > 3.15.0
BuildRequires:  make
BuildRequires:  gtest-devel gmock-devel

ExclusiveArch:  x86_64

%description
The Intel® Query Processing Library (Intel® QPL) is an open-source library to 
provide high-performance query processing operations on Intel CPUs. Intel® QPL 
is aimed to support capabilities of the new Intel® In-Memory Analytics 
Accelerator (Intel® IAA) available on Next Generation Intel® Xeon® Scalable 
processors, codenamed Sapphire Rapids processor, such as very high throughput 
compression and decompression combined with primitive analytic functions, 
as well as to provide highly-optimized SW fallback on other Intel CPUs. 
Intel QPL primarily targets applications such as big-data and in-memory 
analytic databases.

%package devel
Summary:	header files for %{name}.
Requires:	%{name} = %{version}-%{release}

%description devel
Header file for %{name}.

%package tests
Summary:        tests package for %{name}.
Requires:       %{name} = %{version}-%{release}
Requires:       %{name}-devel = %{version}-%{release}
Requires:       accel-config

%description tests
Test file for %{name}.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n %{name}-%{version} -p1

%build
%cmake
%cmake_build

%install
%cmake_install

find %{buildroot}%{_libdir} -iname '*.a' -exec rm -rf {} \;
find %{buildroot}%{_libdir} -iname '*.la' -exec rm -rf {} \;

%generate_compatibility_deps

mkdir -p %{buildroot}/%{_sysconfdir}/%{name}
mv %{buildroot}/%{_bindir}/configs %{buildroot}/%{_sysconfdir}/%{name}/configs

for _bin_file in tests cross_tests init_tests scripts test_frontend; do
        mv %{buildroot}/%{_bindir}/$_bin_file %{buildroot}/%{_bindir}/%{name}_$_bin_file
done

mkdir -p %{buildroot}/%{_datadir}/%{name}/
cp -r tools/testdata %{buildroot}/%{_datadir}/%{name}/

%files
%license LICENSE
%doc CONTRIBUTING.md
%dir %{abidir}
%dir %{_sysconfdir}/%{name}
%{_sysconfdir}/%{name}/configs

%files devel
%{_libdir}/libqplhl.so
%{_libdir}/cmake/*
%{abidir}/libqplhl.dump
%{_includedir}/%{name}/qpl.h
%{_includedir}/%{name}/qpl.hpp
%{_includedir}/%{name}/c_api
%{_includedir}/%{name}/cpp_api

%files tests
%{_bindir}/%{name}_cross_tests
%{_bindir}/%{name}_tests
%{_bindir}/%{name}_init_tests
%{_bindir}/%{name}_scripts
%{_bindir}/%{name}_test_frontend
%{_datadir}/%{name}/testdata
%{abidir}/*-option.list
%{abidir}/libaccel-config.dump

%files doc
%doc README.md SECURITY.md 

%changelog
* Mon Oct 24 2022 happy_orange <songnannan@linux.alibaba.com> - 0.2.0-2
- bugfix the path error of configs

* Mon Oct 17 2022 happy_orange <songnannan@linux.alibaba.com> - 0.2.0-1
- Init package from upstream
